<?php
namespace Financeiro\Repositories;

class Adiantareceb extends \Doctrine\ORM\EntityRepository
{

    public function verificaAdiantamento($cdempresa,$cdcliente,$nrorg)
    {
        $sql = "SELECT
               A.VRTOTADIA,
               A.VRDISPONIVEL,
               A.NRLANCTONF,
               A.NRSEQVENREC,
               A.NRPARCELAREC,
               A.CDFILIAL,
               A.VRORIGINAL,
               A.IDMARCADO,
               A.VRDESCONTO,
               A.IDTPIJURCLIE,
               A.CDCLIENTE,
               A.NMRAZSOCCLIE,
               A.NRINSJURCLIE,
               A.DTATUAVENREC
                FROM
                   (SELECT
                       NVL(SUM(AR.VRADIANTAREC), 0) VRTOTADIA,
                       CR.VRATUAREC - NVL(SUM(AR.VRADIANTAREC), 0) VRDISPONIVEL,
                       CR.NRLANCTONF,
                       CR.NRSEQVENREC,
                       CR.NRPARCELAREC,
                       CR.CDFILIAL,
                       CR.VRATUAREC   VRORIGINAL,
                       'N'   AS       IDMARCADO ,
                        0             VRDESCONTO,
                       CL.IDTPIJURCLIE,
                       CL.NMRAZSOCCLIE,
                       CL.NRINSJURCLIE,
                       CR.DTATUAVENREC,
                       NF.CDCLIENTE
                   FROM
                       NOTAFISCAL    NF,
                       CONTARECEBER  CR,
                       ADIANTARECEB  AR,
                       CLIENTE       CL,
                       TIPOCTRECEBER TP
                   WHERE
                       NF.CDCLIENTE       = CL.CDCLIENTE     AND
                       NF.CDEMPRESA       = :P_CDEMPRESA     AND
                       NF.CDCLIENTE       = :P_CDCLIENTE     AND
                       NF.NRORG           = :P_NRORG         AND
                       CR.CDFILIAL        = NF.CDFILIAL      AND
                       CR.NRLANCTONF      = NF.NRLANCTONF    AND
                       AR.CDFILIAL    (+) = CR.CDFILIAL      AND
                       AR.NRLANCTONF  (+) = CR.NRLANCTONF    AND
                       AR.NRSEQVENREC (+) = CR.NRSEQVENREC   AND
                       AR.NRPARCELAREC(+) = CR.NRPARCELAREC  AND
                       CR.CDTPCTRECEB     = TP.CDTPCTRECEB   AND
                       TP.IDTPCTRECEBER     = '2'            AND

                       CR.IDSTATREC       = 'B'              AND
                       NF.IDNFDISPFIN = 'S'
                   GROUP BY
                       CR.NRLANCTONF,
                       CR.NRSEQVENREC,
                       CR.NRPARCELAREC,
                       CR.CDFILIAL,
                       CR.VRATUAREC,
                       'N',
                       0 ,
                       CL.IDTPIJURCLIE,
                       CL.NMRAZSOCCLIE,
                       CL.NRINSJURCLIE,
                       CR.DTATUAVENREC,
                       NF.CDCLIENTE
                   HAVING
                       NVL(SUM(AR.VRADIANTAREC),0) <> CR.VRATUAREC) A";

        $params = array(
            "P_NRORG"        => $nrorg,
            "P_CDEMPRESA"     => $cdempresa,
            "P_CDCLIENTE"   => $cdcliente,

        );
        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function verificaDevolucao($cdempresa,$cdcliente,$nrorg)
    {
        $sql = "SELECT DISTINCT
   IDMARCADO,
   DOCUMENTO,
   FILIDEVO,
   NRNFDEVO,
   FILIVENDA,
   NRNFVENDA,
   DTEMISSAO,
   DTENTRSAID,
   NRLANCTONF,
   VRDISPONIVEL,
   VRDESCONTO,
   VRNFDEVOL,
   NRINSJURCLIE,
   IDTPIJURCLIE,
   NMRAZSOCCLIE
FROM
   (SELECT
       'N'   AS        IDMARCADO  ,
       NFD.NRNOTAFISC || '/' || NFD.CDSERIEENTR DOCUMENTO,
       NFD.CDFILIAL      FILIDEVO,
       NFD.NRLANCTONF    NRNFDEVO,
       NFC.CDFILIAL      FILIVENDA,
       NFC.NRLANCTONF    NRNFVENDA,
       NFD.DTEMISSAO,
       NFC.DTENTRSAID,
       NFC.NRLANCTONF,
       NFD.VRNOTAFISC - NVL(NFD.VRDEVOLNFUTL, 0) VRDISPONIVEL,
       0               VRDESCONTO,
       NFD.VRNOTAFISC  VRNFDEVOL,
       CL.NRINSJURCLIE,
       CL.IDTPIJURCLIE,
       CL.NMRAZSOCCLIE
    FROM
       NOTAFISCAL   NFD,
       ITEMNOTAFISC ITF,
       NOTAFISCAL   NFC,
       CLIENTE      CL,
       TIPOOPERAC   TP
    WHERE
       (NFC.CDCLIENTE   = CL.CDCLIENTE)  AND
       (NFC.CDCLIENTE   = :P_CDCLIENTE)  AND
       (NFC.CDEMPRESA    = :P_CDEMPRESA)   AND
       (NFC.NRORG       = :P_NRORG)        AND
       (NFD.CDFILIAL     = ITF.CDFILIAL)   AND
       (NFD.NRLANCTONF   = ITF.NRLANCTONF) AND
       (ITF.CDFILIALIT     = NFC.CDFILIAL)   AND
       (ITF.NRLANCTONFIT   = NFC.NRLANCTONF) AND
       (NFD.IDENTRSAIDOP = TP.IDENTRSAIDOP)AND
       (NFD.CDTIPOOPER   = TP.CDTIPOOPER)  AND
       (NFD.IDENTRSAIDOP = 'E') AND
       (NFD.IDSTATUS IN ('A', 'E'))        AND
       (TP.IDOPERDEVONF IN ('S'))          AND
       (NFD.IDNFDISPFIN = 'S') AND
       (NFD.VRNOTAFISC  <> NVL(NFD.VRDEVOLNFUTL, 0)) AND
       NOT EXISTS (SELECT CDFILIAL
                     FROM CONTAPAGAR CP
                    WHERE CP.CDFILIAL = NFD.CDFILIAL AND
                          CP.NRLANCTONF = NFD.NRLANCTONF)
       AND EXISTS (SELECT CDFILIAL
                     FROM CONTARECEBER
                    WHERE CDFILIAL = NFC.CDFILIAL
                      AND NRLANCTONF = NFC.NRLANCTONF))
ORDER BY
    DOCUMENTO,
    DTEMISSAO";

        $params = array(
            "P_NRORG"        => $nrorg,
            "P_CDEMPRESA"     => $cdempresa,
            "P_CDCLIENTE"   => $cdcliente,

        );
        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

}