/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MOTIVOOPER                                               */
/* Tabela : MOTIVOOPER                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 15/01/2009 - Frederico Gonalves Moreira da Costa                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE
TRIGGER DTULTATU_MOTIVOOPER
BEFORE INSERT OR UPDATE OR DELETE
ON MOTIVOOPER FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF(NVL(:OLD.CDEMPRESA     ,0) <> NVL(:NEW.CDEMPRESA     ,0)) OR
        (NVL(:OLD.CDTIPOOPERBEM ,0) <> NVL(:NEW.CDTIPOOPERBEM ,0)) OR
        (NVL(:OLD.CDMOTIVOOPER  ,0) <> NVL(:NEW.CDMOTIVOOPER  ,0)) OR
        (NVL(:OLD.NMMOTIVOOPER  ,0) <> NVL(:NEW.NMMOTIVOOPER  ,0)) OR
        (NVL(:OLD.NMABREVMOTOPER,0) <> NVL(:NEW.NMABREVMOTOPER,0)) THEN
         :NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE,CDFILICACHE,DSKEYCACHE,DTULTATUCACH)
      VALUES ('MOTIVOOPER','','CDEMPRESA='||:OLD.CDEMPRESA||';CDTIPOOPERBEM='||:OLD.CDTIPOOPERBEM||';CDMOTIVOOPER='||:OLD.CDMOTIVOOPER||';',SYSDATE);
   END IF;
END;
/
ALTER TABLE MOTIVOOPER MODIFY DTULTATU DEFAULT SYSDATE
/
UPDATE MOTIVOOPER SET DTULTATU = SYSDATE WHERE DTULTATU IS NULL
/
-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_MOTIVOOPER','5.05.119'); END;
/

